package com.sun.xml.internal.bind.v2.model.impl;

import java.util.UUID;
import com.sun.xml.internal.bind.v2.runtime.Name;
import javax.xml.stream.XMLStreamException;
import java.util.Collections;
import javax.xml.datatype.Duration;
import java.math.BigDecimal;
import java.math.BigInteger;
import javax.xml.transform.Transformer;
import javax.activation.DataSource;
import java.io.UnsupportedEncodingException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.stream.StreamResult;
import java.io.OutputStreamWriter;
import javax.activation.MimeType;
import javax.activation.MimeTypeParseException;
import com.sun.xml.internal.bind.v2.util.DataSourceSource;
import javax.xml.transform.Source;
import com.sun.istack.internal.ByteArrayDataSource;
import javax.activation.DataHandler;
import com.sun.xml.internal.bind.v2.runtime.output.Pcdata;
import javax.imageio.stream.ImageOutputStream;
import java.util.Iterator;
import javax.imageio.ImageWriter;
import javax.xml.bind.helpers.ValidationEventImpl;
import com.sun.xml.internal.bind.v2.util.ByteArrayOutputStreamEx;
import java.awt.Graphics;
import java.awt.MediaTracker;
import java.awt.Component;
import java.awt.image.BufferedImage;
import java.io.InputStream;
import java.io.IOException;
import javax.imageio.ImageIO;
import java.io.ByteArrayInputStream;
import java.awt.Image;
import java.net.URISyntaxException;
import java.net.URI;
import java.net.MalformedURLException;
import com.sun.xml.internal.bind.v2.runtime.unmarshaller.UnmarshallingContext;
import com.sun.xml.internal.bind.v2.TODO;
import java.net.URL;
import com.sun.xml.internal.bind.WhiteSpaceProcessor;
import java.io.File;
import java.util.Date;
import java.util.GregorianCalendar;
import javax.xml.datatype.DatatypeConstants;
import java.util.Calendar;
import org.xml.sax.SAXException;
import java.util.ArrayList;
import java.security.AccessController;
import java.security.PrivilegedAction;
import java.util.HashMap;
import javax.xml.bind.MarshalException;
import javax.xml.datatype.XMLGregorianCalendar;
import com.sun.xml.internal.bind.DatatypeConverterImpl;
import com.sun.xml.internal.bind.v2.runtime.unmarshaller.Base64Data;
import com.sun.xml.internal.bind.api.AccessorException;
import com.sun.xml.internal.bind.v2.runtime.XMLSerializer;
import javax.xml.namespace.QName;
import java.util.List;
import java.util.Map;
import com.sun.xml.internal.bind.v2.runtime.Transducer;
import com.sun.xml.internal.bind.v2.model.runtime.RuntimeBuiltinLeafInfo;
import java.lang.reflect.Type;

public abstract class RuntimeBuiltinLeafInfoImpl<T> extends BuiltinLeafInfoImpl<Type, Class> implements RuntimeBuiltinLeafInfo, Transducer<T>
{
    public static final Map<Type, RuntimeBuiltinLeafInfoImpl<?>> LEAVES;
    public static final RuntimeBuiltinLeafInfoImpl<String> STRING;
    private static final String DATE = "date";
    public static final List<RuntimeBuiltinLeafInfoImpl<?>> builtinBeanInfos;
    public static final String MAP_ANYURI_TO_URI = "mapAnyUriToUri";
    private static final Map<QName, String> xmlGregorianCalendarFormatString;
    private static final Map<QName, Integer> xmlGregorianCalendarFieldRef;
    
    private RuntimeBuiltinLeafInfoImpl(Class type, QName... typeNames) {
        super(type, typeNames);
        RuntimeBuiltinLeafInfoImpl.LEAVES.put(type, this);
    }
    
    public final Class getClazz() {
        return (Class)this.getType();
    }
    
    public final Transducer getTransducer() {
        return this;
    }
    
    public boolean useNamespace() {
        return false;
    }
    
    public final boolean isDefault() {
        return true;
    }
    
    public void declareNamespace(T o, XMLSerializer w) throws AccessorException {
    }
    
    public QName getTypeName(T instance) {
        return null;
    }
    
    private static QName createXS(String typeName) {
        return new QName("http://www.w3.org/2001/XMLSchema", typeName);
    }
    
    private static byte[] decodeBase64(CharSequence text) {
        if ((text instanceof Base64Data)) {
            Base64Data base64Data = (Base64Data)text;
            return base64Data.getExact();
        }
        return DatatypeConverterImpl._parseBase64Binary(text.toString());
    }
    
    private static void checkXmlGregorianCalendarFieldRef(QName type, XMLGregorianCalendar cal) throws MarshalException {
        StringBuilder buf = new StringBuilder();
        int bitField = (int)RuntimeBuiltinLeafInfoImpl.xmlGregorianCalendarFieldRef.get(type);
        int l = 1;
        int pos = 0;
        while (bitField != 0) {
            int bit = bitField & 0x1;
            bitField >>>= 4;
            ++pos;
            if (bit == 1) {
                switch (pos) {
                    case 1: {
                        if (cal.getSecond() == Integer.MIN_VALUE) {
                            buf.append("  ").append(Messages.XMLGREGORIANCALENDAR_SEC);
                            continue;
                        }
                        continue;
                    }
                    case 2: {
                        if (cal.getMinute() == Integer.MIN_VALUE) {
                            buf.append("  ").append(Messages.XMLGREGORIANCALENDAR_MIN);
                            continue;
                        }
                        continue;
                    }
                    case 3: {
                        if (cal.getHour() == Integer.MIN_VALUE) {
                            buf.append("  ").append(Messages.XMLGREGORIANCALENDAR_HR);
                            continue;
                        }
                        continue;
                    }
                    case 4: {
                        if (cal.getDay() == Integer.MIN_VALUE) {
                            buf.append("  ").append(Messages.XMLGREGORIANCALENDAR_DAY);
                            continue;
                        }
                        continue;
                    }
                    case 5: {
                        if (cal.getMonth() == Integer.MIN_VALUE) {
                            buf.append("  ").append(Messages.XMLGREGORIANCALENDAR_MONTH);
                            continue;
                        }
                        continue;
                    }
                    case 6: {
                        if (cal.getYear() == Integer.MIN_VALUE) {
                            buf.append("  ").append(Messages.XMLGREGORIANCALENDAR_YEAR);
                            continue;
                        }
                        continue;
                    }
                }
            }
            else {
                continue;
            }
        }
        if (buf.length() > 0) {
            throw new MarshalException(Messages.XMLGREGORIANCALENDAR_INVALID.format(new Object[] { type.getLocalPart() }) + buf.toString());
        }
        return;
    }
    
    RuntimeBuiltinLeafInfoImpl(Class x0, QName[] x1, RuntimeBuiltinLeafInfoImpl.1 x2) {
        this(x0, x1);
    }
    
    static byte[] access$100(CharSequence x0) {
        return decodeBase64(x0);
    }
    
    static void access$200(QName x0, XMLGregorianCalendar x1) throws MarshalException {
        checkXmlGregorianCalendarFieldRef(x0, x1);
    }
    
    static QName access$400(String x0) {
        return createXS(x0);
    }
    
    static {
        LEAVES = new HashMap();
        String MAP_ANYURI_TO_URI_VALUE = (String)AccessController.doPrivileged(new PrivilegedAction<String>() {
            @Override
            public String run() {
                return System.getProperty("mapAnyUriToUri");
            }
        });
        QName[] qnames = (MAP_ANYURI_TO_URI_VALUE == null) ? new QName[] { createXS("string"), createXS("anySimpleType"), createXS("normalizedString"), createXS("anyURI"), createXS("token"), createXS("language"), createXS("Name"), createXS("NCName"), createXS("NMTOKEN"), createXS("ENTITY") } : new QName[] { createXS("string"), createXS("anySimpleType"), createXS("normalizedString"), createXS("token"), createXS("language"), createXS("Name"), createXS("NCName"), createXS("NMTOKEN"), createXS("ENTITY") };
        STRING = new RuntimeBuiltinLeafInfoImpl.StringImplImpl(String.class, qnames);
        ArrayList<RuntimeBuiltinLeafInfoImpl<?>> secondaryList = new ArrayList();
        secondaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<Character>(Character.class, new QName[] { createXS("unsignedShort") }) {
            public Character parse(CharSequence text) {
                return Character.valueOf((char)DatatypeConverterImpl._parseInt(text));
            }
            
            @Override
            public String print(Character v) {
                return Integer.toString((int)(char)v);
            }
        });
        secondaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<Calendar>(Calendar.class, new QName[] { DatatypeConstants.DATETIME }) {
            public Calendar parse(CharSequence text) {
                return DatatypeConverterImpl._parseDateTime(text.toString());
            }
            
            @Override
            public String print(Calendar v) {
                return DatatypeConverterImpl._printDateTime(v);
            }
        });
        secondaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<GregorianCalendar>(GregorianCalendar.class, new QName[] { DatatypeConstants.DATETIME }) {
            public GregorianCalendar parse(CharSequence text) {
                return DatatypeConverterImpl._parseDateTime(text.toString());
            }
            
            @Override
            public String print(GregorianCalendar v) {
                return DatatypeConverterImpl._printDateTime(v);
            }
        });
        secondaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<Date>(Date.class, new QName[] { DatatypeConstants.DATETIME }) {
            public Date parse(CharSequence text) {
                return DatatypeConverterImpl._parseDateTime(text.toString()).getTime();
            }
            
            @Override
            public String print(Date v) {
                XMLSerializer xs = XMLSerializer.getInstance();
                QName type = xs.getSchemaType();
                GregorianCalendar cal = new GregorianCalendar(0, 0, 0);
                cal.setTime(v);
                if (type != null && "http://www.w3.org/2001/XMLSchema".equals(type.getNamespaceURI()) && "date".equals(type.getLocalPart())) {
                    return DatatypeConverterImpl._printDate(cal);
                }
                return DatatypeConverterImpl._printDateTime(cal);
            }
        });
        secondaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<File>(File.class, new QName[] { createXS("string") }) {
            public File parse(CharSequence text) {
                return new File(WhiteSpaceProcessor.trim(text).toString());
            }
            
            @Override
            public String print(File v) {
                return v.getPath();
            }
        });
        secondaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<URL>(URL.class, new QName[] { createXS("anyURI") }) {
            public URL parse(CharSequence text) throws SAXException {
                TODO.checkSpec("JSR222 Issue #42");
                try {
                    return new URL(WhiteSpaceProcessor.trim(text).toString());
                }
                catch (MalformedURLException e) {
                    UnmarshallingContext.getInstance().handleError(e);
                    return null;
                }
            }
            
            @Override
            public String print(URL v) {
                return v.toExternalForm();
            }
        });
        if (MAP_ANYURI_TO_URI_VALUE == null) {
            secondaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<URI>(URI.class, new QName[] { createXS("string") }) {
                public URI parse(CharSequence text) throws SAXException {
                    try {
                        return new URI(text.toString());
                    }
                    catch (URISyntaxException e) {
                        UnmarshallingContext.getInstance().handleError(e);
                        return null;
                    }
                }
                
                @Override
                public String print(URI v) {
                    return v.toString();
                }
            });
        }
        secondaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<Class>(Class.class, new QName[] { createXS("string") }) {
            public Class parse(CharSequence text) throws SAXException {
                TODO.checkSpec("JSR222 Issue #42");
                try {
                    String name = WhiteSpaceProcessor.trim(text).toString();
                    ClassLoader cl = UnmarshallingContext.getInstance().classLoader;
                    if (cl == null) {
                        cl = Thread.currentThread().getContextClassLoader();
                    }
                    if (cl != null) {
                        return cl.loadClass(name);
                    }
                    return Class.forName(name);
                }
                catch (ClassNotFoundException e) {
                    UnmarshallingContext.getInstance().handleError(e);
                    return null;
                }
            }
            
            @Override
            public String print(Class v) {
                return v.getName();
            }
        });
        secondaryList.add(new RuntimeBuiltinLeafInfoImpl.PcdataImpl<Image>(Image.class, new QName[] { createXS("base64Binary") }) {
            public Image parse(CharSequence text) throws SAXException {
                try {
                    InputStream is;
                    if ((text instanceof Base64Data)) {
                        is = ((Base64Data)text).getInputStream();
                    }
                    else {
                        is = new ByteArrayInputStream(RuntimeBuiltinLeafInfoImpl.access$100(text));
                    }
                    try {
                        return ImageIO.read(is);
                    }
                    finally {
                        is.close();
                    }
                }
                catch (IOException e) {
                    UnmarshallingContext.getInstance().handleError(e);
                    return null;
                }
            }
            
            private BufferedImage convertToBufferedImage(Image image) throws IOException {
                if ((image instanceof BufferedImage)) {
                    return (BufferedImage)image;
                }
                MediaTracker tracker = new MediaTracker(new Component() {});
                tracker.addImage(image, 0);
                try {
                    tracker.waitForAll();
                }
                catch (InterruptedException e) {
                    throw new IOException(e.getMessage());
                }
                BufferedImage bufImage = new BufferedImage(image.getWidth(null), image.getHeight(null), 2);
                Graphics g = bufImage.createGraphics();
                g.drawImage(image, 0, 0, null);
                return bufImage;
            }
            
            public Base64Data print(Image v) {
                ByteArrayOutputStreamEx imageData = new ByteArrayOutputStreamEx();
                XMLSerializer xs = XMLSerializer.getInstance();
                String mimeType = xs.getXMIMEContentType();
                if (mimeType == null || mimeType.startsWith("image/*")) {
                    mimeType = "image/png";
                }
                try {
                    Iterator<ImageWriter> itr = ImageIO.getImageWritersByMIMEType(mimeType);
                    if (itr.hasNext()) {
                        ImageWriter w = (ImageWriter)itr.next();
                        ImageOutputStream os = ImageIO.createImageOutputStream(imageData);
                        w.setOutput(os);
                        w.write(this.convertToBufferedImage(v));
                        os.close();
                        w.dispose();
                    }
                    else {
                        xs.handleEvent(new ValidationEventImpl(1, Messages.NO_IMAGE_WRITER.format(new Object[] { mimeType }), xs.getCurrentLocation(null)));
                        throw new RuntimeException("no encoder for MIME type " + mimeType);
                    }
                }
                catch (IOException e) {
                    xs.handleError(e);
                    throw new RuntimeException(e);
                }
                Base64Data bd = new Base64Data();
                imageData.set(bd, mimeType);
                return bd;
            }
        });
        secondaryList.add(new RuntimeBuiltinLeafInfoImpl.PcdataImpl<DataHandler>(DataHandler.class, new QName[] { createXS("base64Binary") }) {
            public DataHandler parse(CharSequence text) {
                if ((text instanceof Base64Data)) {
                    return ((Base64Data)text).getDataHandler();
                }
                return new DataHandler(new ByteArrayDataSource(RuntimeBuiltinLeafInfoImpl.access$100(text), UnmarshallingContext.getInstance().getXMIMEContentType()));
            }
            
            public Base64Data print(DataHandler v) {
                Base64Data bd = new Base64Data();
                bd.set(v);
                return bd;
            }
        });
        secondaryList.add(new RuntimeBuiltinLeafInfoImpl.PcdataImpl<Source>(Source.class, new QName[] { createXS("base64Binary") }) {
            public Source parse(CharSequence text) throws SAXException {
                try {
                    if ((text instanceof Base64Data)) {
                        return new DataSourceSource(((Base64Data)text).getDataHandler());
                    }
                    return new DataSourceSource(new ByteArrayDataSource(RuntimeBuiltinLeafInfoImpl.access$100(text), UnmarshallingContext.getInstance().getXMIMEContentType()));
                }
                catch (MimeTypeParseException e) {
                    UnmarshallingContext.getInstance().handleError(e);
                    return null;
                }
            }
            
            public Base64Data print(Source v) {
                XMLSerializer xs = XMLSerializer.getInstance();
                Base64Data bd = new Base64Data();
                String contentType = xs.getXMIMEContentType();
                MimeType mt = null;
                if (contentType != null) {
                    try {
                        mt = new MimeType(contentType);
                    }
                    catch (MimeTypeParseException e) {
                        xs.handleError(e);
                    }
                }
                if ((v instanceof DataSourceSource)) {
                    DataSource ds = ((DataSourceSource)v).getDataSource();
                    String dsct = ds.getContentType();
                    if (dsct != null && (contentType == null || contentType.equals(dsct))) {
                        bd.set(new DataHandler(ds));
                        return bd;
                    }
                }
                String charset = null;
                if (mt != null) {
                    charset = mt.getParameter("charset");
                }
                if (charset == null) {
                    charset = "UTF-8";
                }
                try {
                    ByteArrayOutputStreamEx baos = new ByteArrayOutputStreamEx();
                    Transformer tr = xs.getIdentityTransformer();
                    String defaultEncoding = tr.getOutputProperty("encoding");
                    tr.setOutputProperty("encoding", charset);
                    tr.transform(v, new StreamResult(new OutputStreamWriter(baos, charset)));
                    tr.setOutputProperty("encoding", defaultEncoding);
                    baos.set(bd, "application/xml; charset=" + charset);
                    return bd;
                }
                catch (TransformerException e2) {
                    xs.handleError(e2);
                }
                catch (UnsupportedEncodingException e3) {
                    xs.handleError(e3);
                }
                bd.set(new byte[0], "application/xml");
                return bd;
            }
        });
        secondaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<XMLGregorianCalendar>(XMLGregorianCalendar.class, new QName[] { createXS("anySimpleType"), DatatypeConstants.DATE, DatatypeConstants.DATETIME, DatatypeConstants.TIME, DatatypeConstants.GMONTH, DatatypeConstants.GDAY, DatatypeConstants.GYEAR, DatatypeConstants.GYEARMONTH, DatatypeConstants.GMONTHDAY }) {
            @Override
            public String print(XMLGregorianCalendar cal) {
                XMLSerializer xs = XMLSerializer.getInstance();
                QName type = xs.getSchemaType();
                if (type != null) {
                    try {
                        RuntimeBuiltinLeafInfoImpl.access$200(type, cal);
                        String format = (String)RuntimeBuiltinLeafInfoImpl.xmlGregorianCalendarFormatString.get(type);
                        if (format != null) {
                            return this.format(format, cal);
                        }
                    }
                    catch (MarshalException e) {
                        xs.handleEvent(new ValidationEventImpl(0, e.getMessage(), xs.getCurrentLocation(null)));
                        return "";
                    }
                }
                return cal.toXMLFormat();
            }
            
            public XMLGregorianCalendar parse(CharSequence lexical) throws SAXException {
                try {
                    return DatatypeConverterImpl.getDatatypeFactory().newXMLGregorianCalendar(lexical.toString().trim());
                }
                catch (Exception e) {
                    UnmarshallingContext.getInstance().handleError(e);
                    return null;
                }
            }
            
            private String format(String format, XMLGregorianCalendar value) {
                StringBuilder buf = new StringBuilder();
                int fidx = 0;
                int flen = format.length();
                while (fidx < flen) {
                    char fch = format.charAt(fidx++);
                    if (fch != '%') {
                        buf.append(fch);
                    }
                    else {
                        switch (format.charAt(fidx++)) {
                            case 'Y': {
                                this.printNumber(buf, value.getEonAndYear(), 4);
                                continue;
                            }
                            case 'M': {
                                this.printNumber(buf, value.getMonth(), 2);
                                continue;
                            }
                            case 'D': {
                                this.printNumber(buf, value.getDay(), 2);
                                continue;
                            }
                            case 'h': {
                                this.printNumber(buf, value.getHour(), 2);
                                continue;
                            }
                            case 'm': {
                                this.printNumber(buf, value.getMinute(), 2);
                                continue;
                            }
                            case 's': {
                                this.printNumber(buf, value.getSecond(), 2);
                                if (value.getFractionalSecond() != null) {
                                    String frac = value.getFractionalSecond().toPlainString();
                                    buf.append(frac.substring(1, frac.length()));
                                    continue;
                                }
                                continue;
                            }
                            case 'z': {
                                int offset = value.getTimezone();
                                if (offset == 0) {
                                    buf.append('Z');
                                    continue;
                                }
                                if (offset != Integer.MIN_VALUE) {
                                    if (offset < 0) {
                                        buf.append('-');
                                        offset *= -1;
                                    }
                                    else {
                                        buf.append('+');
                                    }
                                    this.printNumber(buf, offset / 60, 2);
                                    buf.append(':');
                                    this.printNumber(buf, offset % 60, 2);
                                    continue;
                                }
                                else {
                                    continue;
                                }
                            }
                            default: {
                                throw new InternalError();
                            }
                        }
                    }
                }
                return buf.toString();
            }
            
            private void printNumber(StringBuilder out, BigInteger number, int nDigits) {
                String s = number.toString();
                for (int i = s.length(); i < nDigits; ++i) {
                    out.append('0');
                }
                out.append(s);
            }
            
            private void printNumber(StringBuilder out, int number, int nDigits) {
                String s = String.valueOf(number);
                for (int i = s.length(); i < nDigits; ++i) {
                    out.append('0');
                }
                out.append(s);
            }
            
            @Override
            public QName getTypeName(XMLGregorianCalendar cal) {
                return cal.getXMLSchemaType();
            }
        });
        ArrayList<RuntimeBuiltinLeafInfoImpl<?>> primaryList = new ArrayList();
        primaryList.add(RuntimeBuiltinLeafInfoImpl.STRING);
        primaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<Boolean>(Boolean.class, new QName[] { createXS("boolean") }) {
            public Boolean parse(CharSequence text) {
                return DatatypeConverterImpl._parseBoolean(text);
            }
            
            @Override
            public String print(Boolean v) {
                return v.toString();
            }
        });
        primaryList.add(new RuntimeBuiltinLeafInfoImpl.PcdataImpl<byte[]>(byte[].class, new QName[] { createXS("base64Binary"), createXS("hexBinary") }) {
            public byte[] parse(CharSequence text) {
                return RuntimeBuiltinLeafInfoImpl.access$100(text);
            }
            
            public Base64Data print(byte[] v) {
                XMLSerializer w = XMLSerializer.getInstance();
                Base64Data bd = new Base64Data();
                String mimeType = w.getXMIMEContentType();
                bd.set(v, mimeType);
                return bd;
            }
        });
        primaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<Byte>(Byte.class, new QName[] { createXS("byte") }) {
            public Byte parse(CharSequence text) {
                return Byte.valueOf(DatatypeConverterImpl._parseByte(text));
            }
            
            @Override
            public String print(Byte v) {
                return DatatypeConverterImpl._printByte((byte)v);
            }
        });
        primaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<Short>(Short.class, new QName[] { createXS("short"), createXS("unsignedByte") }) {
            public Short parse(CharSequence text) {
                return Short.valueOf(DatatypeConverterImpl._parseShort(text));
            }
            
            @Override
            public String print(Short v) {
                return DatatypeConverterImpl._printShort((short)v);
            }
        });
        primaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<Integer>(Integer.class, new QName[] { createXS("int"), createXS("unsignedShort") }) {
            public Integer parse(CharSequence text) {
                return Integer.valueOf(DatatypeConverterImpl._parseInt(text));
            }
            
            @Override
            public String print(Integer v) {
                return DatatypeConverterImpl._printInt((int)v);
            }
        });
        primaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<Long>(Long.class, new QName[] { createXS("long"), createXS("unsignedInt") }) {
            public Long parse(CharSequence text) {
                return Long.valueOf(DatatypeConverterImpl._parseLong(text));
            }
            
            @Override
            public String print(Long v) {
                return DatatypeConverterImpl._printLong((long)v);
            }
        });
        primaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<Float>(Float.class, new QName[] { createXS("float") }) {
            public Float parse(CharSequence text) {
                return Float.valueOf(DatatypeConverterImpl._parseFloat(text.toString()));
            }
            
            @Override
            public String print(Float v) {
                return DatatypeConverterImpl._printFloat((float)v);
            }
        });
        primaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<Double>(Double.class, new QName[] { createXS("double") }) {
            public Double parse(CharSequence text) {
                return Double.valueOf(DatatypeConverterImpl._parseDouble(text));
            }
            
            @Override
            public String print(Double v) {
                return DatatypeConverterImpl._printDouble((double)v);
            }
        });
        primaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<BigInteger>(BigInteger.class, new QName[] { createXS("integer"), createXS("positiveInteger"), createXS("negativeInteger"), createXS("nonPositiveInteger"), createXS("nonNegativeInteger"), createXS("unsignedLong") }) {
            public BigInteger parse(CharSequence text) {
                return DatatypeConverterImpl._parseInteger(text);
            }
            
            @Override
            public String print(BigInteger v) {
                return DatatypeConverterImpl._printInteger(v);
            }
        });
        primaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<BigDecimal>(BigDecimal.class, new QName[] { createXS("decimal") }) {
            public BigDecimal parse(CharSequence text) {
                return DatatypeConverterImpl._parseDecimal(text.toString());
            }
            
            @Override
            public String print(BigDecimal v) {
                return DatatypeConverterImpl._printDecimal(v);
            }
        });
        primaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<QName>(QName.class, new QName[] { createXS("QName") }) {
            public QName parse(CharSequence text) throws SAXException {
                try {
                    return DatatypeConverterImpl._parseQName(text.toString(), UnmarshallingContext.getInstance());
                }
                catch (IllegalArgumentException e) {
                    UnmarshallingContext.getInstance().handleError(e);
                    return null;
                }
            }
            
            @Override
            public String print(QName v) {
                return DatatypeConverterImpl._printQName(v, XMLSerializer.getInstance().getNamespaceContext());
            }
            
            @Override
            public boolean useNamespace() {
                return true;
            }
            
            @Override
            public void declareNamespace(QName v, XMLSerializer w) {
                w.getNamespaceContext().declareNamespace(v.getNamespaceURI(), v.getPrefix(), false);
            }
        });
        if (MAP_ANYURI_TO_URI_VALUE != null) {
            primaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<URI>(URI.class, new QName[] { createXS("anyURI") }) {
                public URI parse(CharSequence text) throws SAXException {
                    try {
                        return new URI(text.toString());
                    }
                    catch (URISyntaxException e) {
                        UnmarshallingContext.getInstance().handleError(e);
                        return null;
                    }
                }
                
                @Override
                public String print(URI v) {
                    return v.toString();
                }
            });
        }
        primaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<Duration>(Duration.class, new QName[] { createXS("duration") }) {
            @Override
            public String print(Duration duration) {
                return duration.toString();
            }
            
            public Duration parse(CharSequence lexical) {
                TODO.checkSpec("JSR222 Issue #42");
                return DatatypeConverterImpl.getDatatypeFactory().newDuration(lexical.toString());
            }
        });
        primaryList.add(new RuntimeBuiltinLeafInfoImpl.StringImpl<Void>(Void.class, new QName[0]) {
            @Override
            public String print(Void value) {
                return "";
            }
            
            public Void parse(CharSequence lexical) {
                return null;
            }
        });
        List<RuntimeBuiltinLeafInfoImpl<?>> l = new ArrayList(secondaryList.size() + primaryList.size() + 1);
        l.addAll(secondaryList);
        try {
            l.add(new RuntimeBuiltinLeafInfoImpl.UUIDImpl());
        }
        catch (LinkageError linkageError) {}
        l.addAll(primaryList);
        builtinBeanInfos = Collections.unmodifiableList(l);
        xmlGregorianCalendarFormatString = new HashMap();
        Map<QName, String> m = RuntimeBuiltinLeafInfoImpl.xmlGregorianCalendarFormatString;
        m.put(DatatypeConstants.DATETIME, "%Y-%M-%DT%h:%m:%s%z");
        m.put(DatatypeConstants.DATE, "%Y-%M-%D%z");
        m.put(DatatypeConstants.TIME, "%h:%m:%s%z");
        m.put(DatatypeConstants.GMONTH, "--%M--%z");
        m.put(DatatypeConstants.GDAY, "---%D%z");
        m.put(DatatypeConstants.GYEAR, "%Y%z");
        m.put(DatatypeConstants.GYEARMONTH, "%Y-%M%z");
        m.put(DatatypeConstants.GMONTHDAY, "--%M-%D%z");
        xmlGregorianCalendarFieldRef = new HashMap();
        Map<QName, Integer> f = RuntimeBuiltinLeafInfoImpl.xmlGregorianCalendarFieldRef;
        f.put(DatatypeConstants.DATETIME, Integer.valueOf(17895697));
        f.put(DatatypeConstants.DATE, Integer.valueOf(17895424));
        f.put(DatatypeConstants.TIME, Integer.valueOf(16777489));
        f.put(DatatypeConstants.GDAY, Integer.valueOf(16781312));
        f.put(DatatypeConstants.GMONTH, Integer.valueOf(16842752));
        f.put(DatatypeConstants.GYEAR, Integer.valueOf(17825792));
        f.put(DatatypeConstants.GYEARMONTH, Integer.valueOf(17891328));
        f.put(DatatypeConstants.GMONTHDAY, Integer.valueOf(16846848));
    }
    
    private abstract static class StringImpl<T> extends RuntimeBuiltinLeafInfoImpl<T>
    {
        protected StringImpl(Class type, QName... typeNames) {
            super(type, typeNames, null);
        }
        
        public abstract String print(T p0) throws AccessorException;
        
        public void writeText(XMLSerializer w, T o, String fieldName) throws IOException, SAXException, XMLStreamException, AccessorException {
            w.text(this.print(o), fieldName);
        }
        
        public void writeLeafElement(XMLSerializer w, Name tagName, T o, String fieldName) throws IOException, SAXException, XMLStreamException, AccessorException {
            w.leafElement(tagName, this.print(o), fieldName);
        }
    }
    
    private abstract static class PcdataImpl<T> extends RuntimeBuiltinLeafInfoImpl<T>
    {
        protected PcdataImpl(Class type, QName... typeNames) {
            super(type, typeNames, null);
        }
        
        public abstract Pcdata print(T p0) throws AccessorException;
        
        public final void writeText(XMLSerializer w, T o, String fieldName) throws IOException, SAXException, XMLStreamException, AccessorException {
            w.text(this.print(o), fieldName);
        }
        
        public final void writeLeafElement(XMLSerializer w, Name tagName, T o, String fieldName) throws IOException, SAXException, XMLStreamException, AccessorException {
            w.leafElement(tagName, this.print(o), fieldName);
        }
    }
    
    private static class UUIDImpl extends RuntimeBuiltinLeafInfoImpl.StringImpl<UUID>
    {
        public UUIDImpl() {
            super(UUID.class, new QName[] { RuntimeBuiltinLeafInfoImpl.access$400("string") });
        }
        
        public UUID parse(CharSequence text) throws SAXException {
            TODO.checkSpec("JSR222 Issue #42");
            try {
                return UUID.fromString(WhiteSpaceProcessor.trim(text).toString());
            }
            catch (IllegalArgumentException e) {
                UnmarshallingContext.getInstance().handleError(e);
                return null;
            }
        }
        
        @Override
        public String print(UUID v) {
            return v.toString();
        }
    }
    
    private static class StringImplImpl extends RuntimeBuiltinLeafInfoImpl.StringImpl<String>
    {
        public StringImplImpl(Class type, QName[] typeNames) {
            super(type, typeNames);
        }
        
        public String parse(CharSequence text) {
            return text.toString();
        }
        
        @Override
        public String print(String s) {
            return s;
        }
        
        @Override
        public final void writeText(XMLSerializer w, String o, String fieldName) throws IOException, SAXException, XMLStreamException {
            w.text(o, fieldName);
        }
        
        @Override
        public final void writeLeafElement(XMLSerializer w, Name tagName, String o, String fieldName) throws IOException, SAXException, XMLStreamException {
            w.leafElement(tagName, o, fieldName);
        }
    }
}
